
int samples;
bool reset;
float force;
float damp;
float radius;

Texture2D tex <string uiname="Texture";>;
float4x4 FieldsTransform <string uiname="inverse (Fields transform * scale 0.5)";>;

SamplerState mySampler : IMMUTABLE
{
    Filter = MIN_MAG_MIP_POINT;
    AddressU = Clamp;
    AddressV = Clamp;
};

StructuredBuffer<float2> resetPos;
StructuredBuffer<float2> PosVAdd;
struct particle
{
	float2 pos;
	float2 vel;
	
};

RWStructuredBuffer<particle> Output : BACKBUFFER;

//==============================================================================
//COMPUTE SHADER ===============================================================
//==============================================================================

[numthreads(64, 1, 1)]
void CSConstantForce( uint3 DTid : SV_DispatchThreadID )
{
	float PI = 3.14159265;
	if (reset)
	{
		Output[DTid.x].pos = resetPos[DTid.x];
		Output[DTid.x].vel = PosVAdd[DTid.x];
		
	}
	
	else
	{
	float2 p = Output[DTid.x].pos;
	float2 v = Output[DTid.x].vel;
	 float2 pNew ={0,0};
    float2 d_1n ={0,0};	
	for (int i =0; i<samples ;i++){
        pNew.x = cos(((1.0f/samples)*i*2*PI))*radius;
        pNew.y = sin(((1.0f/samples)*i*2*PI))*radius;
	
        d_1n +=  pNew  * tex.SampleLevel(mySampler, mul( p + pNew , FieldsTransform)+0.5,0).r ;
    }

		 float2 fieldsAdd = d_1n * force ;
	
	
		
		
	
	
	Output[DTid.x].vel *= damp;
	Output[DTid.x].vel += fieldsAdd;
    Output[DTid.x].pos +=  Output[DTid.x].vel ;//  ++ float3(PosVel2.xy* force2,0) ;
	
	}
}

//==============================================================================
//TECHNIQUES ===================================================================
//==============================================================================

technique11 simulation
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, CSConstantForce() ) );
	}
}
